Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34921)
@@ -913,20 +1363,14 @@
             Condition => '$format =~ /^int32/',
             # (counts of 72, 85, 86, 93, 94, 96, 104) - PH
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfoUnknown32',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfoUnknown32' },
         },
         {
             Name => 'CanonCameraInfoUnknown16',
             Condition => '$format =~ /^int16/',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfoUnknown16',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfoUnknown16' },
         },
         {
             Name => 'CanonCameraInfoUnknown',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::CameraInfoUnknown',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraInfoUnknown' },
         },
     ],
@@ -1119,13 +1563,16 @@
         ValueConvInv => '"8 $val"',
         PrintConvColumns => 2,
-        PrintConv => { BITMASK => {
-            0 => 'People',
-            1 => 'Scenery',
-            2 => 'Events',
-            3 => 'User 1',
-            4 => 'User 2',
-            5 => 'User 3',
-            6 => 'To Do',
-        } },
+        PrintConv => {
+            0 => '(none)',
+            BITMASK => {
+                0 => 'People',
+                1 => 'Scenery',
+                2 => 'Events',
+                3 => 'User 1',
+                4 => 'User 2',
+                5 => 'User 3',
+                6 => 'To Do',
+            },
+        },
     },
     0x24 => { #PH
@@ -1140,4 +1587,5 @@
         SubDirectory => {
             TagTable => 'Image::ExifTool::Canon::FaceDetect2',
+            # (can't validate because this record uses a 1-byte count instead of a 2-byte count)
         },
     },
@@ -1149,4 +1597,9 @@
             TagTable => 'Image::ExifTool::Canon::AFInfo2',
         },
+    },
+    0x27 => { #PH
+        Name => 'ContrastInfo',
+        Condition => '$$valPt =~ /^\x0a\0/', # (seems to be various versions of this information)
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::ContrastInfo' },
     },
     # 0x27 - value 1 is 1 for high ISO pictures, 0 otherwise
@@ -1162,7 +1615,42 @@
         ValueConvInv => 'pack("H*", $val)',
     },
+    0x29 => { #IB (G9)
+        Name => 'WBInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::WBInfo' },
+    },
     # 0x2d - changes with categories (ref 31)
-    # 0x44 - ShootInfo
-    # 0x62 - UserSetting
+    0x2f => { #PH (G12)
+        Name => 'FaceDetect3',
+        SubDirectory => {
+            Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
+            TagTable => 'Image::ExifTool::Canon::FaceDetect3',
+        },
+    },
+    # 0x32 - if length is 768, starting at offset 4 there are 6 RGGB 1/val int16 records:
+    #        daylight,cloudy,tungsten,fluorescent,flash,kelvin (D30 2001, ref IB)
+    0x35 => { #PH
+        Name => 'TimeInfo',
+        SubDirectory => {
+            Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
+            TagTable => 'Image::ExifTool::Canon::TimeInfo',
+        },
+    },
+    0x38 => { #PH
+        Name => 'BatteryType',
+        Writable => 'undef',
+        Condition => '$count == 76',
+        RawConv => '$val=~/^.{4}([^\0]+)/s ? $1 : undef',
+        RawConvInv => 'substr("\x4c\0\0\0".$val.("\0"x72), 0, 76)',
+    },
+    0x3c => { #PH (G1XmkII)
+        Name => 'AFInfo3',
+        Condition => '$$self{AFInfo3} = 1',
+        SubDirectory => {
+            Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
+            TagTable => 'Image::ExifTool::Canon::AFInfo2',
+        },
+    },
+    # 0x44 (ShootInfo)
+    # 0x62 (UserSetting)
     0x81 => { #13
         Name => 'RawDataOffset',
@@ -1177,5 +1665,5 @@
         # this is an offset to the original decision data block
         # (offset relative to start of file in JPEG images, but NOT DNG images!)
-        IsOffset => '$val and $$exifTool{FILE_TYPE} ne "JPEG"',
+        IsOffset => '$val and $$et{FILE_TYPE} ne "JPEG"',
         Protected => 2,
         DataTag => 'OriginalDecisionData',
@@ -1216,8 +1704,8 @@
     },
     0x95 => { #PH (observed in 5D sample image)
-        Name => 'LensModel',
+        Name => 'LensModel', # (LensName)
         Writable => 'string',
     },
-    0x96 => [ #PH
+    0x96 => [ #PH (CMOSNumber)
         {
             Name => 'SerialInfo',
@@ -1233,18 +1721,42 @@
         },
     ],
-    0x97 => { #PH
-        Name => 'DustRemovalData',
-        # some interesting stuff is stored in here, like LensType and InternalSerialNumber...
+    0x97 => { #PH (also see http://www.freepatentsonline.com/7657116.html)
+        Name => 'DustRemovalData', # (DustDeleteData)
         Writable => 'undef',
         Flags => [ 'Binary', 'Protected' ],
+        # 0x00: int8u  - Version (0 or 1)
+        # 0x01: int8u  - LensInfo ? (1)
+        # 0x02: int8u  - AVValue ? (int8u for version 0, int16u for version 1)
+        # 0x03: int8u  - POValue ? (int8u for version 0, int16u for version 1)
+        # 0x04: int16u - DustCount
+        # 0x06: int16u - FocalLength ?
+        # 0x08: int16u - LensID ?
+        # 0x0a: int16u - Width
+        # 0x0c: int16u - Height
+        # 0x0e: int16u - RAW_Width
+        # 0x10: int16u - RAW_Height
+        # 0x12: int16u - PixelPitch [um * 1000]
+        # 0x14: int16u - LpfDistance [mm * 1000]
+        # 0x16: int8u  - TopOffset
+        # 0x17: int8u  - BottomOffset
+        # 0x18: int8u  - LeftOffset
+        # 0x19: int8u  - RightOffset
+        # 0x1a: int8u  - Year [-1900]
+        # 0x1b: int8u  - Month
+        # 0x1c: int8u  - Day
+        # 0x1d: int8u  - Hour
+        # 0x1e: int8u  - Minutes
+        # 0x1f: int8u  - BrightDiff
+        # Table with DustCount entries:
+        # 0x22: int16u - DustX
+        # 0x24: int16u - DustY
+        # 0x26: int16u - DustSize
     },
     0x98 => { #PH
-        Name => 'CropInfo',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::CropInfo',
-        },
+        Name => 'CropInfo', # (ImageSizeOffset)
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::CropInfo' },
     },
     0x99 => { #PH (EOS 1D Mark III, 40D, etc)
-        Name => 'CustomFunctions2',
+        Name => 'CustomFunctions2', # (CustomFunEx)
         SubDirectory => {
             Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
@@ -1253,11 +1765,9 @@
     },
     0x9a => { #PH
-        Name => 'AspectInfo',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::AspectInfo',
-        },
+        Name => 'AspectInfo', # (AspectRatioInfo)
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::AspectInfo' },
     },
     0xa0 => {
-        Name => 'ProcessingInfo',
+        Name => 'ProcessingInfo', # (DevelopParam)
         SubDirectory => {
             Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
@@ -1272,13 +1782,10 @@
         Name => 'ColorBalance',
         SubDirectory => {
-            # this offset is necessary because the table is interpreted as short rationals
-            # (4 bytes long) but the first entry is 2 bytes into the table.
-            Start => '$valuePtr + 2',
-            Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart-2,$size+2)',
+            Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
             TagTable => 'Image::ExifTool::Canon::ColorBalance',
         },
     },
     0xaa => {
-        Name => 'MeasuredColor',
+        Name => 'MeasuredColor', # (PresetWBDS)
         SubDirectory => {
             Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
@@ -1312,4 +1819,5 @@
             1 => 'sRGB',
             2 => 'Adobe RGB',
+            65535 => 'n/a',
         },
     },
@@ -1332,5 +1840,5 @@
     },
     0xe0 => { #12
-        Name => 'SensorInfo',
+        Name => 'SensorInfo', # (ImageAreaDesc)
         SubDirectory => {
             Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
@@ -1338,30 +1846,24 @@
         },
     },
-    0x4001 => [ #13
+    0x4001 => [ #13 (WBPacket)
         {   # (int16u[582]) - 20D and 350D
             Condition => '$count == 582',
             Name => 'ColorData1',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::ColorData1',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorData1' },
         },
         {   # (int16u[653]) - 1DmkII and 1DSmkII
             Condition => '$count == 653',
             Name => 'ColorData2',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::ColorData2',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorData2' },
         },
         {   # (int16u[796]) - 1DmkIIN, 5D, 30D, 400D
             Condition => '$count == 796',
             Name => 'ColorData3',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::ColorData3',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorData3' },
         },
         {   # (int16u[692|674|702|1227|1250|1251|1337])
             # 40D (692), 1DmkIII (674), 1DSmkIII (702), 450D/1000D (1227)
             # 50D/5DmkII (1250), 500D/7D_pre-prod/1DmkIV_pre-prod (1251),
-            # 1DmkIV/7D/550D_pre-prod (1337), 550D (1338), 1100D (1346)
+            # 1DmkIV/7D/550D_pre-prod (1337), 550D (1338), 60D/1100D (1346)
             Condition => q{
                 $count == 692  or $count == 674  or $count == 702 or
@@ -1370,41 +1872,54 @@
             },
             Name => 'ColorData4',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::ColorData4',
-            },
-        },
-        {   # (int16u[5120]) - G10
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorData4' },
+        },
+        {   # (int16u[5120]) - G10, G7X
             Condition => '$count == 5120',
             Name => 'ColorData5',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::ColorData5',
-            },
-        },
-        {   # (int16u[1273]) - 600D
-            Condition => '$count == 1273',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorData5' },
+        },
+        {   # (int16u[1273|1275]) - 600D (1273), 1200D (1275)
+            Condition => '$count == 1273 or $count == 1275',
             Name => 'ColorData6',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::ColorData6',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorData6' },
+        },
+        {   # (int16u[1312|1313|1316])
+            # 1DX/5DmkIII/650D/700D/M (1312), 6D/70D/100D (1313),
+            # 1DX firmware 1.x (1316), 7DmkII (1506)
+            Condition => '$count == 1312 or $count == 1313 or $count == 1316 or
+                          $count == 1506',
+            Name => 'ColorData7',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorData7' },
+        },
+        {   # (int16u[1560|1592]) - 5DS/5DSR (1560), 80D (1592), 1300D (1353) ref IB
+            Condition => '$count == 1560 or $count == 1592 or $count == 1353 or $count == 1602',
+            Name => 'ColorData8',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorData8' },
+        },
+        {   # (int16u[1816|1820|1824]) - M50 (1820) ref PH, EOS R (1824), EOS RP, SX70 (1816) ref IB
+            Condition => '$count == 1816 or $count == 1820 or $count == 1824',
+            Name => 'ColorData9',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorData9' },
+        },
+        {   # (int16u[2024|3656]) - 1DXmkIII (2024) ref IB, R5/R6 (3656) ref PH
+            Condition => '$count == 2024 or $count == 3656',
+            Name => 'ColorData10',
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorData10' },
         },
         {
             Name => 'ColorDataUnknown',
-            SubDirectory => {
-                TagTable => 'Image::ExifTool::Canon::ColorDataUnknown',
-            },
+            SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorDataUnknown' },
         },
     ],
     0x4002 => { #PH
         # unknown data block in some JPEG and CR2 images
-        # (5kB for most models, but 22kb for 5D and 30D)
+        # (5kB for most models, but 22kb for 5D and 30D, and 43kB for 5DmkII so Drop it)
         Name => 'CRWParam',
         Format => 'undef',
-        Flags => [ 'Unknown', 'Binary' ],
+        Flags => [ 'Unknown', 'Binary', 'Drop' ],
     },
     0x4003 => { #PH
         Name => 'ColorInfo',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::ColorInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorInfo' },
     },
     0x4005 => { #PH
@@ -1414,22 +1929,39 @@
         Flags => [ 'Unknown', 'Binary', 'Drop' ],
     },
-    0x4008 => { #PH guess (1DmkIII)
-        Name => 'BlackLevel', # (BasePictStyleOfUser)
-        Unknown => 1,
-    },
-    0x4010 => { #http://u88.n24.queensu.ca/exiftool/forum/index.php/topic,2933.0.html
-        Name => 'CustomPictureStyleFileName',
+    0x4008 => { #53
+        Name => 'PictureStyleUserDef', # (BasePictStyleOfUser)
+        Writable => 'int16u',
+        Count => 3, # UserDef1, UserDef2, UserDef3
+        PrintHex => 1,
+        SeparateTable => 'PictureStyle',
+        PrintConv => [\%pictureStyles,\%pictureStyles,\%pictureStyles],
+    },
+    0x4009 => { #53
+        Name => 'PictureStylePC', # (BasePictStyleOfUser)
+        Writable => 'int16u',
+        Count => 3, # PC1, PC2, PC3
+        PrintHex => 1,
+        SeparateTable => 'PictureStyle',
+        PrintConv => [\%pictureStyles,\%pictureStyles,\%pictureStyles],
+    },
+    0x4010 => { #forum2933
+        Name => 'CustomPictureStyleFileName', # (PictStyleCaption)
         Writable => 'string',
     },
+    # 0x4011 (PictStyleAppendInfo)
+    # 0x4012 (CustomWBCaption)
     0x4013 => { #PH
-        Name => 'AFMicroAdj',
+        Name => 'AFMicroAdj', # (AFMicroAdjust)
         SubDirectory => {
-            Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
+            # Canon DPP 3.13 is known to truncate this data to 0x14 bytes (from 0x2c),
+            # so specifically check for 0x2c to avoid giving a warning in this case
+            Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size,0x2c)',
             TagTable => 'Image::ExifTool::Canon::AFMicroAdj',
         },
     },
-    0x4015 => {
-        Name => 'VignettingCorr',
-        Condition => '$$valPt !~ /^\0\0\0\0/', # (data may be all zeros for 60D)
+    # 0x4014 (similar to 0x83?)
+    0x4015 => [{
+        Name => 'VignettingCorr', # (LensPacket)
+        Condition => '$$valPt =~ /^\0/ and $$valPt !~ /^\0\0\0\0/', # (data may be all zeros for 60D)
         SubDirectory => {
             # (the size word is at byte 2 in this structure)
@@ -1437,7 +1969,23 @@
             TagTable => 'Image::ExifTool::Canon::VignettingCorr',
         },
-    },
+    },{
+        Name => 'VignettingCorrUnknown1',
+        Condition => '$$valPt =~ /^[\x01\x02\x10\x20]/ and $$valPt !~ /^\0\0\0\0/',
+        SubDirectory => {
+            # (the size word is at byte 2 in this structure)
+            Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart+2,$size)',
+            TagTable => 'Image::ExifTool::Canon::VignettingCorrUnknown',
+        },
+    },{
+        Name => 'VignettingCorrUnknown2',
+        Condition => '$$valPt !~ /^\0\0\0\0/',
+        SubDirectory => {
+            # (the size word is at byte 4 for version 3 of this structure, but not always!)
+            # Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart+4,$size)',
+            TagTable => 'Image::ExifTool::Canon::VignettingCorrUnknown',
+        },
+    }],
     0x4016 => {
-        Name => 'VignettingCorr2',
+        Name => 'VignettingCorr2', # (ImageCorrectActual)
         SubDirectory => {
             # (the size word is actually 4 bytes, but it doesn't matter if little-endian)
@@ -1447,5 +1995,5 @@
     },
     0x4018 => { #PH
-        Name => 'LightingOpt',
+        Name => 'LightingOpt', # (ImageCorrect)
         SubDirectory => {
             Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
@@ -1454,5 +2002,5 @@
     },
     0x4019 => { #20
-        Name => 'LensInfo',
+        Name => 'LensInfo', # (LensInfoForService)
         SubDirectory => {
             TagTable => 'Image::ExifTool::Canon::LensInfo',
@@ -1467,4 +2015,11 @@
         }
     },
+    0x4021 => { #PH
+        Name => 'MultiExp', # (ExifDSTagMultipleExposure)
+        SubDirectory => {
+            Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
+            TagTable => 'Image::ExifTool::Canon::MultiExp',
+        }
+    },
     0x4024 => { #PH
         Name => 'FilterInfo',
@@ -1472,4 +2027,25 @@
             Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
             TagTable => 'Image::ExifTool::Canon::FilterInfo',
+        }
+    },
+    0x4025 => { #PH
+        Name => 'HDRInfo', # (HighDynamicRange)
+        SubDirectory => {
+            Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
+            TagTable => 'Image::ExifTool::Canon::HDRInfo',
+        }
+    },
+    0x4028 => { #PH
+        Name => 'AFConfig', # (AFTabInfo)
+        SubDirectory => {
+            Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
+            TagTable => 'Image::ExifTool::Canon::AFConfig',
+        }
+    },
+    0x403f => { #25
+        Name => 'RawBurstModeRoll',
+        SubDirectory => {
+            Validate => 'Image::ExifTool::Canon::Validate($dirData,$subdirStart,$size)',
+            TagTable => 'Image::ExifTool::Canon::RawBurstInfo',
         }
     },
@@ -1512,4 +2088,5 @@
         Name => 'CanonFlashMode',
         PrintConv => {
+            -1 => 'n/a', # (PH, EOS M MOV video)
             0 => 'Off',
             1 => 'Auto',
@@ -1532,4 +2109,8 @@
             5 => 'Continuous, High', #PH
             6 => 'Silent Single', #PH
+            # ref A: https://exiftool.org/forum/index.php/topic,5701.msg27843.html#msg27843
+            9 => 'Single, Silent', #A
+            10 => 'Continuous, Silent', #A
+            # 11 - seen for SX260
             # 32-34 - Self-timer?
         },
@@ -1547,4 +2128,8 @@
            16 => 'Pan Focus', #PH
            # 137 - Single?
+           256 => 'AF + MF', #PH (NC, EOS M)
+           257 => 'Live View', #forum12082
+           512 => 'Movie Snap Focus', #48
+           519 => 'Movie Servo AF', #PH (NC, EOS M)
         },
     },
@@ -1560,5 +2145,11 @@
             6 => 'CR2', # +THM? (1D,30D,350D)
             7 => 'CR2+JPEG', # (S30)
-            9 => 'Video', # (S95 MOV)
+            9 => 'MOV', # (S95 MOV)
+            10 => 'MP4', # (SX280 MP4)
+            11 => 'CRM', #PH (C200 CRM)
+            12 => 'CR3', #PH (EOS R)
+            13 => 'CR3+JPEG', #PH (EOS R)
+            14 => 'HIF', #PH (NC)
+            15 => 'CR3+HIF', #PH (1DXmkIII)
         },
     },
@@ -1572,4 +2163,8 @@
         PrintConvColumns => 3,
         PrintConv => {
+            # references:
+            # A = http://homepage3.nifty.com/kamisaka/makernote/makernote_canon.htm
+            # B = http://www.burren.cx/david/canon.html
+            # C = DPP 3.11.26
             0 => 'Full auto',
             1 => 'Manual',
@@ -1577,17 +2172,17 @@
             3 => 'Fast shutter',
             4 => 'Slow shutter',
-            5 => 'Night',
-            6 => 'Gray Scale', #PH
+            5 => 'Night', # (C='Night Scene')
+            6 => 'Gray Scale', #PH (A/B/C='Black & White')
             7 => 'Sepia',
             8 => 'Portrait',
             9 => 'Sports',
             10 => 'Macro',
-            11 => 'Black & White', #PH
-            12 => 'Pan focus',
-            13 => 'Vivid', #PH
-            14 => 'Neutral', #PH
-            15 => 'Flash Off',  #8
+            11 => 'Black & White', #PH (A='Black & White', B/C='Pan focus')
+            12 => 'Pan focus', # (A='Pan focus', C='Vivid')
+            13 => 'Vivid', #PH (A='Vivid', C='Neutral')
+            14 => 'Neutral', #PH (A='Natural', C='Black & White')
+            15 => 'Flash Off',  #8 (C=<none>)
             16 => 'Long Shutter', #PH
-            17 => 'Super Macro', #PH
+            17 => 'Super Macro', #PH (C='Macro')
             18 => 'Foliage', #PH
             19 => 'Indoor', #PH
@@ -1619,5 +2214,5 @@
             45 => 'Smile', #PH
             46 => 'Wink Self-timer', #PH
-            47 => 'Fisheye Effect', #PH (SX30IS)
+            47 => 'Fisheye Effect', #PH (SX30IS,IXUS240)
             48 => 'Miniature Effect', #PH (SD4500)
             49 => 'High-speed Burst', #PH
@@ -1625,5 +2220,20 @@
             51 => 'High Dynamic Range', #PH (S95)
             52 => 'Handheld Night Scene', #PH
-            59 => 'Scene Intelligent Auto', #PH (T3i)
+            53 => 'Movie Digest', #PH
+            54 => 'Live View Control', #PH
+            55 => 'Discreet', #PH
+            56 => 'Blur Reduction', #PH
+            57 => 'Monochrome', #PH (SX260 B&W,Sepia,Blue tone)
+            58 => 'Toy Camera Effect', #51
+            59 => 'Scene Intelligent Auto', #PH (T3i) (C='High-speed Burst HQ' !!)
+            60 => 'High-speed Burst HQ', #PH (C='High-speed Burst HQ', same as 59)
+            61 => 'Smooth Skin', #51
+            62 => 'Soft Focus', #PH (SX260,IXUS240)
+            68 => 'Food', #PH (250D)
+            # 83 - seen for EOS M200 (ref PH)
+            84 => 'HDR Art Standard', #PH (80D)
+            85 => 'HDR Art Vivid', #PH (80D)
+            93 => 'HDR Art Bold', #PH (80D)
+            # 83 - seen for EOS M3 night shot (PH)
             257 => 'Spotlight', #PH
             258 => 'Night 2', #PH
@@ -1725,16 +2335,19 @@
             6 => 'M-Dep', #PH
             7 => 'Bulb', #30
+            8 => 'Flexible-priority AE', #ArnoldVanOostrum
         },
     },
     22 => { #4
         Name => 'LensType',
+        Format => 'int16u',
         RawConv => '$val ? $$self{LensType}=$val : undef', # don't use if value is zero
         Notes => 'this value is incorrect for EOS 7D images with lenses of type 256 or greater',
         SeparateTable => 1,
         DataMember => 'LensType',
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
     23 => {
-        Name => 'LongFocal',
+        Name => 'MaxFocalLength',
         Format => 'int16u',
         # this is a bit tricky, but we need the FocalUnits to convert this to mm
@@ -1746,5 +2359,5 @@
     },
     24 => {
-        Name => 'ShortFocal',
+        Name => 'MinFocalLength',
         Format => 'int16u',
         RawConvInv => '$val * ($$self{FocalUnits} || 1)',
@@ -1785,15 +2398,18 @@
         Name => 'FlashBits',
         PrintConvColumns => 2,
-        PrintConv => { BITMASK => {
-            0 => 'Manual', #PH
-            1 => 'TTL', #PH
-            2 => 'A-TTL', #PH
-            3 => 'E-TTL', #PH
-            4 => 'FP sync enabled',
-            7 => '2nd-curtain sync used',
-            11 => 'FP sync used',
-            13 => 'Built-in',
-            14 => 'External', #(may not be set in manual mode - ref 37)
-        } },
+        PrintConv => {
+            0 => '(none)',
+            BITMASK => {
+                0 => 'Manual', #PH
+                1 => 'TTL', #PH
+                2 => 'A-TTL', #PH
+                3 => 'E-TTL', #PH
+                4 => 'FP sync enabled',
+                7 => '2nd-curtain sync used',
+                11 => 'FP sync used',
+                13 => 'Built-in',
+                14 => 'External', #(may not be set in manual mode - ref 37)
+            },
+        },
     },
     32 => {
@@ -1823,7 +2439,13 @@
             0 => 'Off',
             1 => 'On',
-            2 => 'On, Shot Only', #15 (panning for SX10IS)
-            3 => 'On, Panning', #PH (A570IS)
-            4 => 'On, Video', #PH (SX30IS)
+            2 => 'Shoot Only', #15
+            3 => 'Panning', # (A570IS)
+            4 => 'Dynamic', # (SX30IS) (was 'On, Video')
+            # (don't know what bit 0x100 indicates)
+            256 => 'Off (2)',
+            257 => 'On (2)',
+            258 => 'Shoot Only (2)',
+            259 => 'Panning (2)',
+            260 => 'Dynamic (2)',
         },
     },
@@ -1885,4 +2507,6 @@
         },
     },
+    # 47 - related to aspect ratio: 100=4:3,70=1:1/16:9,90=3:2,60=4:5 (PH G12)
+    #      (roughly image area in percent - 4:3=100%,1:1/16:9=75%,3:2=89%,4:5=60%)
 );
 
@@ -2047,4 +2671,5 @@
         Name => 'SequenceNumber',
         Description => 'Shot Number In Continuous Burst',
+        Notes => 'valid only for some models', #PH (eg. not the 5DmkIII)
     },
     10 => { #PH/17
@@ -2126,4 +2751,5 @@
             0 => 'n/a',
             1 => 'Camera Local Control',
+            # 2 - have seen this for EOS M studio picture
             3 => 'Computer Remote Control',
         },
@@ -2334,12 +2960,12 @@
     PrintConvInv => '$val=~s/\s*mm//;$val',
 );
-my %ciShortFocal = (
-    Name => 'ShortFocal',
+my %ciMinFocal = (
+    Name => 'MinFocalLength',
     Format => 'int16uRev', # byte order is big-endian
     PrintConv => '"$val mm"',
     PrintConvInv => '$val=~s/\s*mm//;$val',
 );
-my %ciLongFocal = (
-    Name => 'LongFocal',
+my %ciMaxFocal = (
+    Name => 'MaxFocalLength',
     Format => 'int16uRev', # byte order is big-endian
     PrintConv => '"$val mm"',
@@ -2377,8 +3003,9 @@
         SeparateTable => 1,
         RawConv => '$val ? $val : undef', # don't use if value is zero
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
     0x0e => {
-        Name => 'ShortFocal',
+        Name => 'MinFocalLength',
         Format => 'int16u',
         PrintConv => '"$val mm"',
@@ -2386,5 +3013,5 @@
     },
     0x10 => {
-        Name => 'LongFocal',
+        Name => 'MaxFocalLength',
         Format => 'int16u',
         PrintConv => '"$val mm"',
@@ -2491,8 +3118,9 @@
         SeparateTable => 1,
         RawConv => '$val ? $val : undef', # don't use if value is zero
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
-    0x11 => { %ciShortFocal }, #9
-    0x13 => { %ciLongFocal }, #9
+    0x11 => { %ciMinFocal }, #9
+    0x13 => { %ciMaxFocal }, #9
     0x2d => { #9
         Name => 'FocalType',
@@ -2567,8 +3195,9 @@
         SeparateTable => 1,
         RawConv => '$val ? $val : undef', # don't use if value is zero
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
-    0x11 => { %ciShortFocal },
-    0x13 => { %ciLongFocal },
+    0x11 => { %ciMinFocal },
+    0x13 => { %ciMaxFocal },
     0x36 => { #15
         Name => 'WhiteBalance',
@@ -2610,6 +3239,5 @@
 );
 
-# Canon camera information for 1DmkIII and 1DSmkIII (MakerNotes tag 0x0d)
-# (ref PH unless otherwise noted)
+# Canon camera information for 1DmkIII and 1DSmkIII (MakerNotes tag 0x0d) (ref PH)
 %Image::ExifTool::Canon::CameraInfo1DmkIII = (
     %binaryDataAttrs,
@@ -2626,6 +3254,6 @@
     0x1b => { %ciMacroMagnification }, #(NC)
     0x1d => { %ciFocalLength },
-    0x30 => {
-        Name => 'CameraOrientation', # <-- (always 9th byte after 0xbbbb for all models - Dave Coffin)
+    0x30 => { # <-- (follows pattern /\xbb\xbb(.{64})?\x01\x01\0\0.{4}/s for all models - Dave Coffin)
+        Name => 'CameraOrientation',
         PrintConv => {
             0 => 'Horizontal (normal)',
@@ -2662,8 +3290,9 @@
         Format => 'int16uRev', # value is big-endian
         SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
-    0x113 => { %ciShortFocal },
-    0x115 => { %ciLongFocal },
+    0x113 => { %ciMinFocal },
+    0x115 => { %ciMaxFocal },
     0x136 => { #15
         Name => 'FirmwareVersion',
@@ -2693,7 +3322,5 @@
     0x2aa => { #48
         Name => 'PictureStyleInfo',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::PSInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo' },
     },
     0x45a => { #29
@@ -2732,8 +3359,26 @@
     FIRST_ENTRY => 0,
     PRIORITY => 0,
-    DATAMEMBER => [ 0x57 ],
-    IS_SUBDIR => [ 0x363, 0x368 ],
+    DATAMEMBER => [ 0x00, 0x56, 0x153 ],
+    IS_SUBDIR => [ 0x368 ],
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    NOTES => 'CameraInfo tags for the 1DmkIV.',
+    NOTES => q{
+        CameraInfo tags for the EOS 1D Mark IV.  Indices shown are for firmware
+        versions 1.0.x, but they may be different for other firmware versions.
+    },
+    0x00 => {
+        Name => 'FirmwareVersionLookAhead',
+        Hidden => 1,
+        # look ahead to check location of FirmwareVersion string
+        Format => 'undef[0x1fd]',
+        RawConv => q{
+            my $t = substr($val, 0x1e8, 6); # 1 = firmware 4.2.1
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 1, return undef;
+            $t = substr($val, 0x1ed, 6);    # 2 = firmware 1.0.4
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 2, return undef;
+            $self->Warn('Unrecognized CameraInfo1DmkIV firmware version');
+            $$self{CanonFirm} = 0;
+            return undef;   # not a real tag
+        },
+    },
     0x03 => { %ciFNumber },
     0x04 => { %ciExposureTime },
@@ -2741,5 +3386,5 @@
     0x07 => {
         Name => 'HighlightTonePriority',
-        PrintConv => { 0 => 'Off', 1 => 'On' },
+        PrintConv => \%offOn,
     },
     0x08 => {
